#
# spec file for package perl-Perl-Critic
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Perl-Critic
Version:        1.126
Release:        3.1
%define cpan_name Perl-Critic
Summary:        Critique Perl source code for best-practices
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Perl-Critic/
Source0:        http://www.cpan.org/authors/id/T/TH/THALJEF/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(B::Keywords) >= 1.05
BuildRequires:  perl(Config::Tiny) >= 2
BuildRequires:  perl(Email::Address) >= 1.889
BuildRequires:  perl(Exception::Class) >= 1.23
BuildRequires:  perl(Exporter) >= 5.63
BuildRequires:  perl(File::HomeDir)
BuildRequires:  perl(File::Which)
BuildRequires:  perl(IO::String)
BuildRequires:  perl(List::MoreUtils) >= 0.19
BuildRequires:  perl(Module::Build) >= 0.402400
BuildRequires:  perl(Module::Pluggable) >= 3.1
BuildRequires:  perl(PPI) >= 1.220
BuildRequires:  perl(PPI::Document) >= 1.220
BuildRequires:  perl(PPI::Document::File) >= 1.220
BuildRequires:  perl(PPI::Node) >= 1.220
BuildRequires:  perl(PPI::Token::Quote::Single) >= 1.220
BuildRequires:  perl(PPI::Token::Whitespace) >= 1.220
BuildRequires:  perl(PPIx::Regexp) >= 0.027
BuildRequires:  perl(PPIx::Utilities::Node) >= 1.001
BuildRequires:  perl(PPIx::Utilities::Statement) >= 1.001
BuildRequires:  perl(Perl::Tidy)
BuildRequires:  perl(Pod::Spell) >= 1
BuildRequires:  perl(Readonly) >= 2
BuildRequires:  perl(String::Format) >= 1.13
BuildRequires:  perl(Task::Weaken)
BuildRequires:  perl(Term::ANSIColor) >= 2.02
BuildRequires:  perl(Test::Builder) >= 0.92
BuildRequires:  perl(Test::Deep)
BuildRequires:  perl(version) >= 0.77
Requires:       perl(B::Keywords) >= 1.05
Requires:       perl(Config::Tiny) >= 2
Requires:       perl(Email::Address) >= 1.889
Requires:       perl(Exception::Class) >= 1.23
Requires:       perl(Exporter) >= 5.63
Requires:       perl(File::HomeDir)
Requires:       perl(File::Which)
Requires:       perl(IO::String)
Requires:       perl(List::MoreUtils) >= 0.19
Requires:       perl(Module::Pluggable) >= 3.1
Requires:       perl(PPI) >= 1.220
Requires:       perl(PPI::Document) >= 1.220
Requires:       perl(PPI::Document::File) >= 1.220
Requires:       perl(PPI::Node) >= 1.220
Requires:       perl(PPI::Token::Quote::Single) >= 1.220
Requires:       perl(PPI::Token::Whitespace) >= 1.220
Requires:       perl(PPIx::Regexp) >= 0.027
Requires:       perl(PPIx::Utilities::Node) >= 1.001
Requires:       perl(PPIx::Utilities::Statement) >= 1.001
Requires:       perl(Perl::Tidy)
Requires:       perl(Pod::Spell) >= 1
Requires:       perl(Readonly) >= 2
Requires:       perl(String::Format) >= 1.13
Requires:       perl(Task::Weaken)
Requires:       perl(Term::ANSIColor) >= 2.02
Requires:       perl(Test::Builder) >= 0.92
Requires:       perl(version) >= 0.77
%{perl_requires}

%description
Perl::Critic is an extensible framework for creating and applying coding
standards to Perl source code. Essentially, it is a static source code
analysis engine. Perl::Critic is distributed with a number of the
Perl::Critic::Policy manpage modules that attempt to enforce various coding
guidelines. Most Policy modules are based on Damian Conway's book *Perl
Best Practices*. However, Perl::Critic is *not* limited to PBP and will
even support Policies that contradict Conway. You can enable, disable, and
customize those Polices through the Perl::Critic interface. You can also
create new Policy modules that suit your own tastes.

For a command-line interface to Perl::Critic, see the documentation for the
perlcritic manpage. If you want to integrate Perl::Critic with your build
process, the Test::Perl::Critic manpage provides an interface that is
suitable for test programs. Also, the Test::Perl::Critic::Progressive
manpage is useful for gradually applying coding standards to legacy code.
For the ultimate convenience (at the expense of some flexibility) see the
the criticism manpage pragma.

If you'd like to try the Perl::Critic manpage without installing anything,
there is a web-service available at the http://perlcritic.com manpage. The
web-service does not yet support all the configuration features that are
available in the native Perl::Critic API, but it should give you a good
idea of what it does.

Also, ActivePerl includes a very slick graphical interface to Perl-Critic
called 'perlcritic-gui'. You can get a free community edition of ActivePerl
from the http://www.activestate.com manpage.

%prep
%setup -q -n %{cpan_name}-%{version}
find . -type f -print0 | xargs -0 chmod 644

%build
%{__perl} Build.PL installdirs=vendor
./Build build flags=%{?_smp_mflags}

%check
./Build test

%install
./Build install destdir=%{buildroot} create_packlist=0
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes examples extras LICENSE README README.md tools

%changelog
* Sun Aug 23 2015 coolo@suse.com
- updated to 1.126
  see /usr/share/doc/packages/perl-Perl-Critic/Changes
  1.126 2015-08-10
    [New Policies]
  * Added a policy: ControlStructures::ProhibitYadaOperator - Never use ...
    in production code.
    [Bug Fixes]
  * Fixed problems arising from having -b in your .perltidyrc file. Thanks
    @hjkatz.
  * Removed extra newline from policy names returned by P::C::Config->policies.
    Thanks @ratsbane.
  * `fc` and `say` are now covered by ProhibitUselessTopic. Thanks @JRaspass.
    [Miscellanea]
  * Add more strict/warnings importer modules. Thanks @oalders.
  * Path::Tiny is now recommended over File::Slurp
  * Micro-optimize by calling ->content() directly instead of going
    through the overloads. Thanks @JRaspass.
  * Square brackets are now allowed around your `## no critic` policy
    list. Thanks @zdm.
* Tue Apr 28 2015 coolo@suse.com
- updated to 1.125
  see /usr/share/doc/packages/perl-Perl-Critic/Changes
  1.125 2015-03-02
    [Bug Fixes]
  * Corrected dependency on List::Util::any() to List::MoreUtils::any()
    [Miscellanea]
  * Revised and updated documentation.
  1.124 2015-02-27
    [Policy Changes]
  * The ProhibitUnusedPrivateSubroutines policy can now ignore files that
    use particular modules with 'skip_when_using' option allows of, for
    example, skipping the policy for roles.  Thanks to Mark Fowler.
  * The RequireUseStrict and RequireUseWarnings policies now regard Moose,
    Moo, Mouse, Dancer, Mojolicious, and several other modules as equivalent
    to the strict and warnings pragma.
    [Bug Fixes]
  * The RequireChecked* family of policies has been fixed to accommodate
    version numbers when use-ing the autodie pragma. GH #612. Thanks citrin.
  1.123 2014-11-11
    [Dependencies]
  * Now requires PPI-1.220 which has numerous bug fixes. This may
    eliminate the need for some "## no critic" markers you inserted to
    work around those bugs. The "ProhibitUselessNoCritic" policy should
    help you find them.
    [Miscellanea]
  * Fixed a typo in the Variables::ProhibitPerl4PackageNames message.
* Mon Sep 15 2014 coolo@suse.com
- updated to 1.122
    [Dependencies]
  * Now requires PPI-1.218 which has numerous enahncements and bug fixes.
    Also now requires Readonly-2.00, which obviates the need for Readonly::XS
    to get fast constants.
  * File::HomeDir, File::Which, and Term::ANSIColor are all required now
    instead of being optional or recommended. This simplifies our test code
    and ensures consistent optimal behavior for all users.
    [New Policies]
  * Added two new policies: BuiltinFunctions::ProhibitUselessTopic and
    RegularExpressions::ProhibitUselessTopic.
    [Miscellanea]
  * Updated the perlcritic.el script to use modern Emacs hooks.
    Thanks to @intrigeri and the Debian team for the patch.  Fixes GH #556.
  * Removed all the internal RCS keyword boilerplate blocks that were never
    getting expanded.
* Mon Nov 11 2013 rschweikert@suse.com
- Added new themes based on CERT guidelines.
* Thu Oct 31 2013 rschweikert@suse.com
- update to 1.120
    Bug Fixes:
  * Corrected "Possible precedence issue with control flow operator"
    warning.  This fixes RT #88866
* Mon Sep 30 2013 rschweikert@suse.com
- updated to 1.119
    Bug Fixes:
  * Tests were failing with Config::Tiny 2.17 or later, due to a
    change in the error messages produced by that module.
    This fixes #16 on Github,  #88679 & #88889 on RT.
    Policy Changes:
  * BuiltinFunctions::ProhibitVoidGrep and ::ProhibitVoidMap: grep
    and map called as functions are now allowed in slice operations.
    RT #79289
    Thanks to Wade at Anomaly dot org for the patch.
  * Subroutines::RequireArgUnpacking: Most tests of the size of @_
    are now allowed.  RT #79138
    Other Changes:
  * Modernized our usage of Exporter.  See RT #75300.
    Thanks to Olivier MenguÃ© for the patch.
* Sat Jun  8 2013 rschweikert@suse.com
- updated to 1.118
  Policy Changes:
  * CodeLayout::RequireTidyCode: Revise to work with incompatible
    changes in Perl::Tidy 20120619. RT #77977.
  * TestingAndDebugging::ProhibitNoWarnings: Correct the parse of the
    'no warnings' statement, so that 'no warnings "qw"' is recognized
    as supressing just 'qw' warnings. RT #74647.
  * Miscellanea::RequireRcsKeywords has been moved to the Perl-Critic-More
    distribution,  RT #69546
    Other Changes:
  * Make all unescaped literal "{" characters in regexps into
    character classes. These are deprecated, and became noisy with
    Perl 5.17.0.  RT #77510.
* Tue Feb 14 2012 coolo@suse.com
- updated to 1.117
  New Policies:
  * Variables::ProhibitAugmentedAssignmentInDeclaration reports
    constructs like 'my $x += 1'. Contributed by Mike O'Regan
  Policy Changes:
  * BuiltinFunctions::ProhibitLvalueSubstr: Add explicit 'use version'.
    RT #68498.
  * CodeLayout::ProhibitHardTabs: Add 'pbp' to the default_themes list.
    RT #71093.
  * ControlStructures::ProhibitMutatingListFunctions now understands that
    tr///r (introduced in 5.13.7) does not change its operand.
  * ControlStructures::ProhibitMutatingListFunctions now understands that
    '//=', '<<=', and '>>=' are assignment operators. RT #70901.
  * ErrorHandling::RequireCheckingReturnValueOfEval now allows things
    like grep { eval $_ }. RT #69489.
  * Modules::RequireExplicitPackage now has configuraion option
    allow_import_of, to allow the import of specified modules before
    the package statement. RT #72660.
  * RegularExpressions::ProhibitEnumeratedClasses no longer thinks
    that [A-Za-z_] matches \w. RT #69322.
  * RegularExpressions::ProhibitUnusedCaptures now skips the first
    block of an 'if' or 'elsif' if the regular expression is bound to
    its operand with the '!~' operator. RT #69867.
  * RegularExpressions::ProhibitUnusedCaptures now looks into lists
    and blocks in the replacement portion of the regular expression if
    /e is asserted. RT #72086.
  * RegularExpressions::RequireDotMatchAnything,
    RegularExpressions::RequireExtendedFormatting and
    RegularExpressions::RequireLineBoundaryMatching now honor defaults
    set with 'use re "/modifiers"'. RT #72151.
  * Subroutines::ProhibitManyArgs now recognizes '+' as a prototype
    character.
  * Variables::ProhibitPunctuationVars now recognizes bracketed
    variables embedded in interpolated strings (e.g. "${$}"). For the
    purpose of the 'allow' configuration, these are considered
    equivalent to the unbracketed form. RT #72910.
  Other Changes:
  * Corrected POD in Perl::Critic::PPI::Utils. RT #68898.
  * Perl::Critic::Violation source() method now returns the line
    containing the violation (not the first line) when the statement
    containing the violation spans multiple lines.
* Mon Dec 19 2011 coolo@suse.de
- update to 1.116
    Policy Changes:
  * BuiltInFunctions::ProhibitLvalueSubstr does not report violations
    if the document contains an explicit 'use n.nnn;' where the
    version is before 5.005.  RT #59112
  * Documentation::RequirePodSections no longer blows up on code
    having POD but no =head1. This problem was introduced with RT
    [#59268]. RT #67231
  * RegularExpressions::ProhibitUnusedCapture should more reliably
    find things like s/(a)/${1}2/.  RT #67273.
  * ValuesAndExpressions::ProhibitMagicNumbers and
    Module::RequireVersionVar now treat versions passed as the second
    argument of a 'package' statement the same as versions declared as
    'our $VERSION ...'.  RT #67159
  * Variables::RequireLexicalLoopIterators does not report violations
    if the document contains an explicit 'use n.nnn;' where the
    version is before 5.004.  RT #67760
* Sun Nov  6 2011 rschweikert@suse.com
- Set executable permission for commandline interface (/usr/bin/perlcritic)
* Sat Apr  2 2011 coolo@novell.com
- update to 1.115
  * Fatal error in RegularExpressions::ProhibitUnusedCapture here
    document check.  RT #67116.
  * Internal POD error in Documentation::RequirePodLinksIncludeText.  Patch
    by Salvatore Bonaccorso.  RT #67012
* Thu Mar 31 2011 coolo@novell.com
- update to 1.114
    Policy Changes:
  * Documentation::RequirePodLinksIncludeText now handles nested POD
    formatting. RT #65569
  * Clarified relation of severity numbers to names in Perl::Critic
    POD. RT #66017
  * Removed caveats from Variables::RequireLocalizedPunctuationVars,
    no longer necessary with PPI 1.208. RT #65514
  * Have InputOutput::RequireBriefOpen attempt to expand scope as
    necessary to deal with the case where the open() and the
    corresponding close() are not in the same scope. RT #64437
  * RegularExpressions::ProhibitUnusedCapture now looks inside
    double-quotish things. RT #38942.
  * RegularExpressions::ProhibitUnusedCapture now takes logical
    alternation into account, so that (e.g.)
    if ( /(a)/ || /(b)/ ) {
    say $1;
    }
    is not a violation. RT #38942.
  * ValuesAndExpressions::ProhibitCommaSeparatedStatements now
    recognizes 'return { foo => 1, bar => 2 }' as containing a hash
    constructor, not a block. This was fixed by PPI 1.215. RT #61301.
  * ValuesAndExpressions::ProhibitCommaSeparatedStatements now
    recognizes 'bless { foo => 1, bar => 2 }' as containing a hash
    constructor, not a block. This was fixed by PPI 1.215. RT #64132.
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Fri Nov 19 2010 chris@computersalat.de
- update to 1.109
  - Bug Fixes:
  * ValuesAndExpressions::RequireInterpolationOfMetachars fix due to changes
    in Email::Address 1.890.  Note that this may find problems in code that
    it didn't before, e.g. q<'@foo'>.
* Thu Jul 15 2010 chris@computersalat.de
- update to 1.108
  o for full list please see Changes file
- recreated by cpanspec 1.78
  o fix deps
- added bcond_with test for
  o Test::Deep
  o Test::Memory::Cycle
- split up old pkg to perl-Perl-Critic_1_106
  o 1.108 builds only on suse_version > 1120
* Wed Jul 14 2010 chris@computersalat.de
- update to 1.106
  * NamingConventions::Capitalization fix for PPI 1.212.  RT #57348
- recreated by cpanspec 1.78
  o fix deps
* Mon Nov 23 2009 rschweikert@novell.com
- Initial build of perlcritic
